/**
 * @description 鉴权指令
 * 当传入的权限当前用户没有时，会移除该组件
 * 用例：<Tag v-auth">text</Tag> 或者：<Tag v-auth="'user:编辑'">text</Tag>
 * */
import store from '@/store';

export default {
    inserted (el, binding, vnode) {
        let btnText = ''
        if(binding.value){
            btnText = binding.value
        }else{
            btnText = `${vnode.context.$route.name}:${el.innerText}`
        }
        const btnPermissions = store.state.btnPermissions;

        if (btnText && btnPermissions && btnPermissions.length) {
            const isPermission = btnPermissions.includes(btnText);
            if (!isPermission) {
                el.parentNode && el.parentNode.removeChild(el);
            }
        }
    }
}
