import router from './index';
import store from '@/store';
import Setting from '@/setting';
import generateRoutes from '@/libs/route/generateRoutes';
import bus from '@/libs/bus';

router.beforeEach((to, from, next) => {
    document.title = to.meta.title ? `${to.meta.title} | ${Setting.titleSuffix}` : Setting.titleSuffix;
    const role = sessionStorage.getItem(Setting.usernameKey);
    if (!role && to.path !== '/login') {
        next('login')
        // if(to.fullPath != '/404' && to.fullPath != '/'){
        //     next({
        //         path: 'login',
        //         query: {redirect: to.fullPath}
        //     })
        // }else{
        //     next('login')
        // }
    } else if(role && to.path == '/login') {
        next('dashboard')
    } else {
        to.meta.title != '404' && store.commit('sidebarData',{sidebarMenu: to.meta.sidebar})
        if(to.meta.sidebar){
            bus.$emit('showMenu', true)
        }else{
            bus.$emit('showMenu', false)
        }
        next();
    }
});

Setting.dynamicRoute && generateRoutes()