export default [
    {
        path: '/',
        redirect: 'login'
    },
    {
        path: '/',
        component: () => import('@/layouts/home/index.vue'),
        meta: { title: '自述文件' },
        children: [
            {
                name: 'personalcenter',
                path: 'personalcenter',
                component: () => import('@/pages/personalcenter.vue'),
                meta: {
                    title: '个人中心'
                }
            },
            {
                name: 'matchDetail',
                path: 'matchDetail',
                component: () => import('@/pages/matchDetail.vue'),
                meta: { title: '大赛简介',sidebar: 'match' }
            },
            {
                name: 'courseSection',
                path: 'courseSection',
                component: () => import('@/pages/courseSection.vue'),
                meta: { title: '课程预览' }
            },

            // {
            //     name: 'course',
            //     path: 'course',
            //     component: () => import('@/pages/course.vue'),
            //     meta: { title: '课程管理' }
            // },
            // {
            //     name: 'addcourse',
            //     path: 'addcourse',
            //     component: () => import('@/pages/addCourse.vue'),
            //     meta: { title: '新增课程' }
            // },

            {
                // 国际化组件
                name: 'i18n',
                path: 'i18n',
                component: () => import( '@/pages/i18n.vue'),
                meta: { title: '国际化' }
            },
            {
                name: '404',
                path: '404',
                component: () => import('@/pages/404.vue'),
                meta: { title: '404' }
            },
            {
                name: '403',
                path: '403',
                component: () => import('@/pages/403.vue'),
                meta: { title: '403' }
            }
        ]
    },
    {
        name: 'login',
        path: '/login',
        component: () => import('@/pages/login.vue'),
        meta: { title: '登录' }
    },
]