import Vue from 'vue';
import Vuex from 'vuex';
Vue.use(Vuex);
const store = new Vuex.Store({
    state: {
        avatar: 'https://cube.elemecdn.com/3/7c/3ea6beec64369c2642b92c6726f1epng.png',
        customerId:'',
        courseId:'',
        userId: '',
        roleId: '',
        manager:{},
        provinceList: [],
        configId: '',
        systemId: '',
        orderId: '',
        userLoginId: '',
        accountRole: '',
        name:'',
        account:'',
        phone:'',
        schoolId: '',
        schoolName: '',
        routes: [],
        btnPermissions: [],
        indexPath: '',
        sidebarMenu: false,
        matchId: '',
    },
    mutations:{
        userData (state, payload) {
            state.userId = payload.user_id,
            state.roleId = payload.roleId
        },
        customerData (state, payload) {
            state.customerId = payload.customer_id
        },
        courseData (state, payload) {
            state.courseId = payload.course_id
        },
        managerData (state, payload) {
            state.manager = payload.form
        },
        provinceData (state, payload) {
            state.provinceList = payload.provinceList
        },
        configData (state, payload) {
            state.configId = payload.config_id
        },
        systemData (state, payload) {
            state.systemId = payload.system_id
            state.orderId = payload.order_id
        },
        setAvatarData (state, payload) {
            state.avatar = payload.avatar
        },
        userLoginData (state, payload) {
            state.userLoginId = payload.userId
            state.accountRole = payload.accountRole
        },
        userInfo(state,payload){
            state.name = payload.name
            state.account = payload.account
            state.phone = payload.phone
            state.schoolId = payload.schoolId
            state.schoolName = payload.schoolName
        },
        sidebarData (state, payload) {
            state.sidebarMenu = payload.sidebarMenu
        },
        matchData (state, payload) {
            state.matchId = payload.matchId
        },
        addRoutesData (state, payload) {
            state.routes = payload.routes
        },
        addBtnPerData (state, payload) {
            state.btnPermissions = payload.btnPermissions
        },
        addIndex (state, payload) {
            state.indexPath = payload.path
        }
    }
});
 
export default store;