const Setting = require('./src/setting.env')

// 引入等比适配插件
const px2rem = require('postcss-px2rem')

// 配置基本大小
const postcss = px2rem({
  // 基准大小 baseSize，需要和rem.js中相同
  remUnit: 16
})

// 使用等比适配插件
module.exports = {
  lintOnSave: Setting.lintOnSave,
  css: {
    loaderOptions: {
      sass: {
        prependData: `@import "@/styles/var.scss";`
      },
      // postcss: {
      //   plugins: [
      //     postcss
      //   ]
      // }
    }
  },
  publicPath: Setting.publicPath,
  outputDir: Setting.outputDir,
  assetsDir: Setting.assetsDir,
  devServer: {
    port: 8088
  //   proxy: {
  //     "/api": {
  //       target: "http://192.168.0.106:8080",
  //       changeOrigin: true,
  //       ws: true,
  //       pathRewrite: {
  //         "^/api": ""
  //       }
  //     }
  //   }
  }
}